package industries.sunshine.planningpoker

import scala.scalajs.js
import scala.scalajs.js.annotation.*
import com.raquo.laminar.api.L.{*, given}
import io.laminext.fetch.Fetch
import io.laminext.fetch.FetchResponse
import scala.scalajs.js.Dynamic.{global => g}

import concurrent.ExecutionContext.Implicits.global

object Header {
  def render(loggedInObserver: Observer[Boolean], loggedInSignal: Signal[Boolean]): Element = {
    val (responsesStream, responseReceived) = EventStream.withCallback[FetchResponse[String]]

    val logoutButton = button(
      "Leave Room",
      className := "border border-black m-2 p-2 absolute right-2",
      onClick.flatMap(_ => Fetch.get("/api/logout").text) --> responseReceived,
      responsesStream --> Observer(resp => g.console.info(s"${resp.toString()}")),
      responsesStream.collect { case resp if resp.ok => false } --> loggedInObserver
    )
    val cachedEmpty = emptyNode

    div(
      className := "h-24 w-full flex flex-for justify-center items-center bg-green-200",
      p(className := "text-2xl", "Planning Poker Kazbegi (nonpretty prealpha version)"),
      child <-- loggedInSignal.map(if (_) logoutButton else cachedEmpty)
    )
  }
}
