package industries.sunshine.planningpoker

import scala.scalajs.js
import com.raquo.laminar.api.L.{*, given}
import industries.sunshine.planningpoker.common.Models.RoundStateView
import com.raquo.airstream.core.Signal
import io.laminext.fetch.Fetch
import scala.scalajs.js.Dynamic.{global => g}

import concurrent.ExecutionContext.Implicits.global

object TableControls {
  def render(roundSignal: Signal[RoundStateView]): Element = {
    div(
      child <-- roundSignal.map {
        case RoundStateView.Viewing(_)   => newPollButton()
        case RoundStateView.Voting(_, _) => endPollButton()
      }
    )
  }

  val commonButtonStyle = "border-2 border-black rounded-xl m-2 p-1"
  def endPollButton(): Element = button(
    className := commonButtonStyle,
    "end voting",
    onClick.flatMap(_ => Fetch.get("/api/end-voting").text) --> Observer(resp =>
      g.console.info(resp.toString())
    )
  )

  def newPollButton(): Element = button(
    className := commonButtonStyle,
    "start next round",
    onClick.flatMap(_ => Fetch.get("/api/new-poll").text) --> Observer(resp =>
      g.console.info(resp.toString())
    )
  )

}
